#!/usr/bin/perl -w -I.
use strict;

#  ---------------------------------------------------------------------
#   manually add a record to the Box (not from WWW)
#    v1.0
#    April 2002
#  ------------------+--------------------+-----------------------------
#   Hussein Suleman  |   hussein@vt.edu   |    www.husseinsspace.com    
#  ------------------+--------------------+-+---------------------------
#   Department of Computer Science          |        www.cs.vt.edu       
#     Digital Library Research Laboratory   |       www.dlib.vt.edu      
#  -----------------------------------------+-------------+-------------
#   Virginia Polytechnic Institute and State University   |  www.vt.edu  
#  -------------------------------------------------------+-------------


# set URL of Box interface
my $baseURL = 'http://oai.dlib.vt.edu/~hussein/cgi-bin/ODL-Box/Box/test1/box.pl';


use FindBin;
use lib "$FindBin::Bin/../../lib";

use XOAI::XOAISP;


sub main
{
   # template for a new record
   my $metadata = "<dc xmlns=\"http://purl.org/dc/elements/1.1/\" xsi:schemaLocation=\"http://purl.org/dc/elements/1.1/ http://www.openarchives.org/OAI/1.1/dc.xsd\">\n\n".
                  "  <title>test from populate script</title>\n".
                  "  <creator>populator</creator>\n".
                  "  <subject>population</subject>\n\n".
                  "</dc>\n";
   my $sets = 'populateset';
   my $metadataPrefix = 'oai_dc';

   # add the record using the Box interface
   my $xoai = new XOAI::XOAISP ($baseURL);
   my $response = $xoai->doXOAI ('PutRecord', {
      metadata => $metadata,
      metadataPrefix => $metadataPrefix,
      sets => $sets
   });

   # check the result code
   if ($response->code != 200)
   { print "Error : ".$response->code." ".$response->message."\n"; }
   else
   { print "OK.\n"; }
}

main;
