#  ---------------------------------------------------------------------
#   General database implementation operations for Suggest
#    v1.0
#    April 2002
#  ------------------+--------------------+-----------------------------
#   Hussein Suleman  |   hussein@vt.edu   |    www.husseinsspace.com    
#  ------------------+--------------------+-+---------------------------
#   Department of Computer Science          |        www.cs.vt.edu       
#     Digital Library Research Laboratory   |       www.dlib.vt.edu      
#  -----------------------------------------+-------------+-------------
#   Virginia Polytechnic Institute and State University   |  www.vt.edu  
#  -------------------------------------------------------+-------------


package ODL::Suggest::SuggestDB;


use DBI;


# open database and create if necessary
sub openDatabase
{
   my ($database, $dbusername, $dbpassword, $table) = @_;
   
   my $dbh = DBI->connect ($database, $dbusername, $dbpassword, { PrintError => 0 });

   # check for existance of index
   my $sth = $dbh->prepare ("select seq from $table limit 1");
   $sth->execute;
   my @row = $sth->fetchrow_array;
   $sth->finish;
   if ($#row > -1)
   {
      return $dbh;
   }
   
   # make new tables in database
   $sth = $dbh->do ("create table $table (".
                    "subject varchar(200) not null, ".
                    "object varchar(200) not null, ".
                    "datestamp integer not null, ".
                    "seq integer not null auto_increment, ".
                    "primary key (subject,object), ".
                    "index seq (seq)".
                    ")");

   $sth = $dbh->do ("create index datestamp on $table (datestamp)");
   $sth = $dbh->do ("create index object on $table (object)");

   return $dbh;
}


1;

